﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace SXTippster.Tools
{
    class PBSTools
    {

        private static readonly byte[] IDs = { 200, 32, 4, 1, 127, 238, 66, 31, 53, 240, 99, 105, 16, 3, 117, 82 };
        

        public static byte[] Protect(byte[] data)
        {
            try
            {
                // Encrypt the data using DataProtectionScope.CurrentUser. The result can be decrypted 
                //  only by the same current user. 
                return ProtectedData.Protect(data, IDs, DataProtectionScope.CurrentUser);
            }
            catch (CryptographicException e)
            {
                Console.WriteLine("Data was not encrypted. An error occurred.");
                Console.WriteLine(e.ToString());
                return null;
            }
        }

        public static byte[] Unprotect(byte[] data)
        {
            try
            {
                //Decrypt the data using DataProtectionScope.CurrentUser. 
                return ProtectedData.Unprotect(data, IDs, DataProtectionScope.CurrentUser);
            }
            catch (CryptographicException e)
            {
                Console.WriteLine("Data was not decrypted. An error occurred.");
                Console.WriteLine(e.ToString());
                return null;
            }
        }


        public static byte[] EncryptInMemoryData(byte[] Buffer, MemoryProtectionScope Scope)
        {
            if (Buffer.Length <= 0)
                throw new ArgumentException("Buffer");
            if (Buffer == null)
                throw new ArgumentNullException("Buffer");

            int l = Buffer.Length % 16;
            byte[] tmp = Buffer;
            byte[] tmp2 = new byte[/*(Buffer.Length + (16 - l))*2*/1024];
            Array.Copy(tmp, tmp2, tmp.Length);
            // Encrypt the data in memory. The result is stored in the same same array as the original data.
            ProtectedMemory.Protect(tmp2, Scope);
            return tmp2;
        }

        public static byte[] DecryptInMemoryData(byte[] Buffer, MemoryProtectionScope Scope)
        {
            if (Buffer == null)
                throw new ArgumentNullException("Buffer");

            if (Buffer.Length <= 0)
                throw new ArgumentException("Buffer");
           

                        
            int l = Buffer.Length % 16;
            
            byte[] tmp = (byte []) Buffer.Clone();
            ProtectedMemory.Unprotect(tmp,Scope);
            
           
            return tmp;
        }
    }
}
